<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'criid',
    label: '主键',
    component: 'Input',
    hidden: true
  },{
    field: 'indexsetCode',
    label: '指标集编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'code',
    label: '科目编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'beginDate',
    label: '开始日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'endDate',
    label: '结束日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'itemName',
    label: '科目名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'itemOrder',
    label: '排序',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'frequency',
    label: '频度',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'isOrgCollect',
    label: '是否机构汇总',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'status',
    label: '状态',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'conCode',
    label: '对照指标编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'itemType1',
    label: '业务类型1',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'itemType2',
    label: '业务类型2',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'itemType3',
    label: '业务类型3',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'itemType4',
    label: '业务类型4',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'itemType5',
    label: '业务类型5',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'indexType',
    label: '指标类型',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'indexcalType',
    label: '指标计算类型',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'indexdataType',
    label: '指标数据类型',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'indexdataPrecision',
    label: '指标数据精度',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'indexdataUnit',
    label: '指标数据项单位',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  indexsetCode: [required()],
  code: [required()],
  beginDate: [required()],
  endDate: [required()],
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

